#Sample Link List Program
#Compiled on HP-UX B.10.20.A 9000
#Compile command   cc -Aa linked_list.c
#Creates executable a.out


#include <stdio.h>
#include <stdlib.h>

typedef struct ns
{
  int data;
  struct ns *next;
} node;

void add_to_list (node **head, int value)
/* Adds to begining of linked list */
{
  node *temp;
  temp = (node *) malloc (sizeof(node));
  temp->next = *head;
  *head = temp;
  temp->data = value;
}

void add_to_last(node **head, int value)
/* Adds at the end of linked list */
{
  node *temp, *curr;
  temp = (node *) malloc (sizeof(node));

  curr = *head;

  while (curr->next)
  {
    curr = curr->next;
  }
  curr->next = temp;
  temp->data = value;
  temp->next = NULL;
}

void print_list (node *head)
/* Prints the linked list */
{
  printf("\nPrinting the link list-\n");

  if (head == NULL)
    printf("Empty list\n");

  while (head != NULL)
  {
    printf("Value : %d\n", head->data);
    head = head->next;
  }
}

void remove_from_start(node **head)
/* Removes the first node of linked list */
{
  if (*head != NULL)
  {
    node *temp = *head;
    *head = (*head)->next;
    free(temp);
  }
}

void remove_from_last(node **head)
/* Removes the last node of linked list */
{
  node *curr, *prev;
  curr = *head;

  while (curr->next)
  {
    prev = curr;
    curr = curr->next;
  }
  prev->next=NULL;
  free(curr);
}

void remove_from_search(node **head, int value)
/* Removes the node with specified value */
{
  node *curr, *prev;
  short found_flag = 0;
  curr = *head;

  while (curr->next)
  {
    if (curr->data == value)
    {
      found_flag = 1;
      break;
    }
    prev = curr;
    curr = curr->next;
  }

  if (found_flag)
  {
    prev->next = curr->next;
    free(curr);
  }
  else
  {
    printf("%d value not found in the link list\n", value);
  }
}

main()
{
  node *head = NULL;

  add_to_list(&head, 5);
  add_to_list(&head, 11);
  add_to_list(&head, 21);
  add_to_list(&head, 21);
  add_to_list(&head, 1);
  add_to_list(&head, 56);
  add_to_last(&head, 73);
  print_list(head);
  /* List should look like- 56,1,21,21,11,5,73*/

  remove_from_start(&head);
  print_list(head);
  remove_from_start(&head->next);
  print_list(head);
  remove_from_search(&head,5);
  print_list(head);
  remove_from_last(&head);
  print_list(head);

}
